<template>
    <div>
  <div class="page-title">
    <h3>Новая запись</h3>
  </div>

  <Loader v-if="loading" />

  <p v-else-if="!categories.length" class="center" >Categeory is null. <router-link to="/categories">For create a new category</router-link> </p>

  <form v-else class="form" @submit.prevent="submitHandler" >
    <div class="input-field" >
      <select ref="select" v-model="category" >
        <option v-for="c in categories" :key="c.id" :value="c.id"
        >{{c.title}}</option>
      </select>
      <label>Выберите категорию</label>
    </div>

    <p>
      <label>
        <input
            class="with-gap"
            name="type"
            type="radio"
            value="income"
            v-model="type"
        />
        <span>Доход</span>
      </label>
    </p>

    <p>
      <label>
        <input
            class="with-gap"
            name="type"
            type="radio"
            value="outcome"
            v-model="type"
        />
        <span>Расход</span>
      </label>
    </p>

    <div class="input-field">
      <input v-model.number="amount"
          id="amount"
          type="number"
          :class="{invalid: v$.amount.$dirty && !v$.amount.required }"
      >
      <label for="amount">Сумма</label>
      <small class="helper-text invalid" v-for="(error, index) of v$.amount.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
    </div>

    <div class="input-field">
      <input v-model="description"
          id="description"
          type="text"
          :class="{invalid: v$.description.$dirty && !v$.description.required }"
      >
      <label for="description">Описание</label>
      <small class="helper-text invalid" v-for="(error, index) of v$.description.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
    </div>

    <button class="btn waves-effect waves-light" type="submit">
      Создать
      <i class="material-icons right">send</i>
    </button>
  </form>
</div>
</template>

<script>
import { useVuelidate } from "@vuelidate/core";
import { required, minValue } from "@vuelidate/validators";
import {mapGetters} from 'vuex'


export default {
  name: 'record',
  setup() {
    return { v$: useVuelidate() };
  },
  validations() {
    return {
      amount: { required, minValue: minValue(1)},
      description: { required },
      category: { required }
    };
  },
  data: ()=>({
    loading: true,
    categories: [],
    select: null,
    category: null,
    type:'income',
    amount:1,
    description:''
  }),
  async mounted(){
    this.categories=await this.$store.dispatch('fetchCategories');
    this.loading=false;

    if(this.categories.length){
      this.category=this.categories[0].id;
    }

    setTimeout(()=>{
      M.updateTextFields();
      this.select=M.FormSelect.init(this.$refs.select)
    },0);
    
  },
  beforeUnmount() {
    if (this.select && this.select.destroy) {
      this.select.destroy();
    }
  },
  computed: {
    ...mapGetters(['info']),
    canCreateRecord(){

      if(this.type ==='income'){
        return true;
      }

      return this.info.bill >= this.amount;
    }
  },
  methods: {
    async submitHandler() {
      this.v$.$touch();
      if (this.v$.$error) return;

      if(this.canCreateRecord){
         const formdata = {
        amount: this.amount,
        categoryId: this.category,
        description: this.description,
        type: this.type,
        date: new Date().toJSON(),
      };

      try{ 
        const record = await this.$store.dispatch('createRecord',formdata);
        
        const bill=this.type === 'income' ? this.amount+ this.info.bill:this.info.bill-this.amount;
        await this.$store.dispatch('updateInfo',{bill});

        this.$message('Record is successfully updated');

        this.v$.reset();
        this.amount=1;
        this.description='';
        // this.$emit('updated',formdata);
        // console.log(new_category);
      }catch(e){
        console.log({e});
         this.$error(e.code);
        // this.$error(messages[this.$route.query.message] || "Nima xato ketganini tushunmadim")
      }



        console.log("OK");
      }else{
        this.$message(`Your karman is pustoy (${this.amount - this.info.bill})`);
      }
      
    }
  }
}
</script>